Button = Object:extend()

function Button:new()
  self.width = 300
  self.height = 50
  self.x = 250
  self.inside = false
  self.outaction = function()
    --The action when you exit the button with your mouse
  end
  self.insideaction = function()
    --The action when you enter the button with your mouse
  end
  self.action = function()
    --The action when you click the button
  end
end

function Button:update(dt)
  if pressed and self.inside then self.action() end
end

function Button:draw()
  if pointInRectangle(love.mouse.getX(), love.mouse.getY(), self.x, self.y, self.width, self.height) then
    self.c = {255, 255, 255, 255}
    if not self.inside then
      love.audio.play(menusound)
      self.inside = true
      self.insideaction()
    end
  else
    self.c = self.color
    if self.inside then
      self.inside = false
      self.outaction()
    end
  end
  font = love.graphics.getFont()
  love.graphics.setColor(self.c)
  love.graphics.rectangle("fill", self.x, self.y, self.width, self.height)
  love.graphics.setColor(0, 0, 0, 255)
  love.graphics.print(self.text, self.x + self.width/2 - font:getWidth(self.text), self.y + self.height/2 - font:getHeight(), 0, 2, 2)
end