Player = Object:extend()

function Player:new()
  self.color = {0, 0, 0, 255}
  self.id = id
  self.image = love.graphics.newImage("Textures/player.png")
  self.width = self.image:getWidth()
  self.height = self.image:getHeight()
  self.x = love.math.random(0, 800 - self.width)
  self.y = -self.height
  self.xspeed = 0
  self.yspeed = 0
  self.onGround = false
  self.onGroundText = "false"
  self.dead = false
  self.m = 1
  if gamemode == 1 then self.r = math.pi else self.r = 0 end
  self.deathtimer = 0
  self.deadsound = true
  if gamemode == 3 then
    self.color[1] = love.math.random(255)
    self.color[2] = love.math.random(255)
    self.color[3] = love.math.random(255)
  end
  if self.id == 1 then self.score = score1 end
  if self.id == 2 then self.score = score2 end
  if self.id == 3 then self.score = score3 end
  if self.id == 4 then self.score = score4 end
end

function Player:update(dt)
  if #alives == 1 and self.id == alives[1].id then self.dead = false end
  if not self.dead then 
    self.xspeed = 0
    if #alives == 1 then self.deathtimer = self.deathtimer + dt end
    if self.deathtimer > 3 then 
      self.dead = 1 
      love.audio.stop(death)
      love.audio.play(death)
      self.score = self.score + 5
      if self.id == 1 then score1 = self.score end
      if self.id == 2 then score2 = self.score end
      if self.id == 3 then score3 = self.score end
      if self.id == 4 then score4 = self.score end
    end
    if not self.onGround then 
      self.yspeed = self.yspeed + gravity * dt * mult
      --self.onGroundText = "false"
    else
      self.yspeed = 0
      --self.onGroundText = "true"
    end
    
    if self.id ~= 4 then
      if love.keyboard.isScancodeDown(self.up) and (self.onGround or self.doubleJump) then self.yspeed = jumpSpeed end
      if love.keyboard.isScancodeDown(self.left) then self.xspeed = self.xspeed - speed end
      if love.keyboard.isScancodeDown(self.right) then self.xspeed = self.xspeed + speed end
      --self.y = self.y + self.yspeed * dt
    elseif self.id == 4 then
      self.xspeed = speed * Joystick:getAxis(1)
      if Joystick:isDown(3) and self.onGround then self.yspeed = jumpSpeed end
      --self.y = self.y + self.yspeed * dt + 2 * self.speed * Joystick:getAxis(2) * dt
    end
    
    self.x = self.x + self.xspeed * dt * mult
    self.y = self.y + self.yspeed * dt * mult
    
    if self.x < -self.width then self.x = windowWidth end
    if self.x > windowWidth then self.x = -self.width end
    if self.y > windowHeight then self.y = -self.height end
  else
    if self.m > 0 then self.m = self.m * 0.8 end
    if self.deadsound then
      love.audio.stop(death)
      love.audio.play(death)
      self.deadsound = false
      self.score = self.score + 5 - #alives
    end
    if self.id == 1 then score1 = self.score end
    if self.id == 2 then score2 = self.score end
    if self.id == 3 then score3 = self.score end
    if self.id == 4 then score4 = self.score end
  end
end

function Player:draw()
  love.graphics.setColor(self.color)
  if not self.dead then 
    if highplayer == self.id then love.graphics.draw(crown, self.x + self.width / 2 + 13, self.y + self.height/ 2 - 18, 0, 1, 1, self.width / 2, self.height / 2) end
    love.graphics.draw(self.image, self.x + self.width / 2, self.y + self.height/ 2, self.r, 1 + self.yspeed / 1400, 1 - self.yspeed / 2100, self.width / 2, self.height / 2)
    --Shows the area until the slow-motion effect activates
    --if gamemode == 5 then love.graphics.circle("line", self.x, self.y, 300) end
    --Shows the hitbox
    --love.graphics.rectangle("line", self.x, self.y, self.width, self.height)
    love.graphics.setColor(0, 0, 0, 255)
    --Show all useful variables in movement: xspeed, yspeed and onGround
    --love.graphics.print(self.xspeed, self.x, self.y)
    --love.graphics.print(self.yspeed, self.x, self.y + 10)
    --love.graphics.print(self.onGroundText, self.x, self.y + 20)
    love.graphics.print(self.score, self.x + self.width / 2 - font:getWidth(self.score) / 2, self.y + self.height / 2 - font:getHeight() / 2)
  else
    love.graphics.draw(self.image, self.x + self.width / 2, self.y + self.height, 0, 1, self.m, self.width / 2, self.height)
  end
end